﻿using Newtonsoft.Json.Linq;
using System.Collections.Generic;

namespace EDJournal {
    public class RedeemVoucherEntry : Entry {
        protected override void Initialise() {
            Amount = JSON.Value<int>("Amount");
            Type = JSON.Value<string>("Type");

            /* according to API, there should be a Factions structure */
            JToken factions = JSON.GetValue("Factions");
            if (factions != null) {
                foreach (JObject faction in factions.Children<JObject>()) {
                    string faction_name = faction.Value<string>("Faction");
                    if (faction_name == null || faction_name.Length <= 0) {
                        continue;
                    }
                    Factions.Add(faction_name);
                }
            }

            /* but there also might be just a Faction entry */
            string single_faction = JSON.Value<string>("Faction");
            if (single_faction != null) {
                Factions.Add(single_faction);
            }
        }

        public int Amount { get; set; } = 0;
        public string Type { get; set; } = "Bounty";
        public List<string> Factions { get; set; } = new List<string>();
    }
}
